/* global process */

var er = undefined;
try {

  // Implement next javascript missing functions!
  if (!String.prototype.startsWith) {
    Object.defineProperty(String.prototype, 'startsWith', {
        value: function(search, rawPos) {
            var pos = rawPos > 0 ? rawPos|0 : 0;
            return this.substring(pos, pos + search.length) === search;
        }
    });
  }

  var express = require('./packages/express');
  var http = require('http');
  var XMR = require('./xmrclient.js');
  //const router = require('./app');
  var app = express();

  var server = http.createServer(app);

//  process.env['DEBUG']='*';
// 
//  process.on('uncaughtException', function(err) {
//    er = err;
//    var url = 'http://192.168.1.170:8080?err='+err.message;
//    if(err.stack){
//      url = url + 'stack='+err.stack;
//    }
//    http.get(url, function(){});
//  });

  var clients = {};

  try {
    var io = require('./packages/socket.io/lib/index')(server);
/**/
  } catch (e) {
    console.error(e);
    er = {e:e};
    er.message = e.toString();
    er.requireStack = (e.requireStack)?e.requireStack:"";
    er.io = 'Unable to find io!';
    
    var stack;
    if (e.stack){
      stack = e.stack;
    }else{
      stack = new Error().stack;
    }
      
    er.stack = stack;
    app.get('/ioerror', function(req, res) {
      res.send(er);
    });
    var io = {
      addListener: function(){}
    };
    
  }


  io.addListener('connection', function(client){
    client.emit('log', JSON.stringify({data:'Welcome'}));
    
    console.log('Got client '+client.id);
    clients[client.id] =client;
  
    client.on('disconnect', function(){
      delete clients[client.id];
    });
  
    // Add custom XMR commands here
    client.on('xmr_connect', function(data){
      try {
        console.log("Tasker:Client "+client.id+" send connect to "+data.host + " at port "+data.port);
        XMR.connect(data.host, data.port);
      } catch (e) {
        
        er = {e:e};
        if (e.message){
          er.message = e.message;
        }
        if (e.stack){
          er.stack = e.stack;
        }
        if (e.requireStack){
          er.requireStack = e.requireStack;
        }
        console.error('Tasker:XMR error',JSON.stringify(er));
        io.emit('xmr_error', er);
        //client.emit('xmr_error',e.message);
      }
    });
  
    client.on('xmr_disconnect', function(){
      console.log("Tasker:Client "+client.id+" send disconnect");
      XMR.disconnect();
    });
  
    client.on('xmr_connection_status', function(fn){
      //console.log("Client "+client.id+" send disconnect");
      fn(XMR.connection_status());
    });
    
    client.on('xmr_subscribe', function(data){
      console.log("Tasker:Client "+client.id+" send subscribe to "+data);
      XMR.subscribe(data);
    });
    
    client.on('xmr_unsubscribe', function(data){
      console.log("Tasker:Client "+client.id+" send unsubscribe to "+data);
      XMR.unsubscribe(data);
    });
  
    client.on('xmr_createKey', function(fn){
      console.log("Tasker:Client "+client.id+" send create key ");
      fn(XMR.createKey());
    });
    
    client.on('xmr_importKey', function(data, fn){
      //console.log("Tasker:Client "+client.id+" send import key from ", JSON.stringify(data));
      var ret = XMR.importKey(data);
      if (fn){
        fn(ret);
      }
    });
    
    client.on('xmr_exportKey', function(fn){
      console.log("Tasker:Client "+client.id+" send export key ");
      fn(XMR.exportKey());
    });
  });

  XMR.addListener('connected',function(){
    console.log('Tasker:XMR connected');
    io.emit('xmr_connected');
  });

  XMR.addListener('disconnected',function(){
    console.log('Tasker:XMR disconnected');
    io.emit('xmr_disconnected');
  });

  XMR.addListener('error', function(e){
//    er = {e:e};
//    if (e.message){
//      er.message = e.message;
//    }
//    if (e.stack){
//      er.stack = e.stack;
//    }
//    if (e.requireStack){
//      er.requireStack = e.requireStack;
//    }

    //var stack = new Error().stack;
    console.error('Tasker:XMR error',e);
    io.emit('xmr_error', e);
  });

  XMR.addListener('data', function(data){
    console.info('Tasker:xmr_data',data);
    io.emit('xmr_data', data);
  });


  //app.use(router);

  //app.use(express.static('app_static'));
  
  
  var i = 0;
  app.get('/status', function(req, res) {
    res.send('Tick:'+i);
  });
  server.listen(11223, '127.0.0.1');


/**/
} catch (e) {
  var stack = new Error().stack;
  
  er = {e:e, stack : stack};
  

  app.get('/error', function(req, res) {
    res.send(er);
  });

  server.listen(11223, '127.0.0.1');
  
}
/**/
function tick(){
  i++;
  console.log('Tasker tick',i);
  //io.emit('xmr_data', {'tick':i});
}

function getGlobalError(){
  return er;
}

exports.tick = tick;
exports.getGlobalError = getGlobalError;

  
